/* sf10d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__10 = 10;

doublereal sf10d_c(doublereal *x, integer *l, integer *ierr)
{
    /* Initialized data */

    static doublereal sys059 = 1.7e308;
    static doublereal pp[9] = { 103.0259990294628,2781.556951284448,
            19273.80098600572,52759.23966621326,67868.97902962336,
            44234.46358185698,14773.24772717615,2371.138845157722,
            142.7782534685513 };
    static doublereal qq[9] = { 172.3547893760824,3220.845810178108,
            18937.36743618128,47461.83671148535,58017.2702086999,
            36670.51460217709,12017.60312809182,1906.135146578901,
            113.9205640609552 };
    static doublereal f[4] = { -1.641445283729907,-296.0165789295884,
            -17733.78468495299,-403203.4076114548 };
    static doublereal g[3] = { -250.6497244587799,29865.71316305403,
            -1612813.630445819 };
    static doublereal sys073 = 2.2227587494851e-162;
    static doublereal sys055 = 2.225073858507202e-308;
    static doublereal one = 1.;
    static doublereal zero = 0.;
    static doublereal const__ = -.11593151565841;
    static doublereal xmax = 177.85287909124;
    static doublereal p[5] = { -3.272279992574785,-513.5620533725103,
            -25470.74686782375,-356272.9668888909,-149269.5386816498 };
    static doublereal q[3] = { -228.6835794674987,25325.71801733452,
            -1287566.524373463 };

    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double exp(doublereal), log(doublereal), sqrt(doublereal);

    /* Local variables */
    static doublereal temp, sumf, sumg, sump, sumq, a;
    static integer i__;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal x1, xx;

    *ierr = 0;
    if (*x <= zero) {
        goto L8;
    }
    a = one;
    if (*l != 1 && *l != 2) {
        goto L10;
    }
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L2;
    }
L1:
    if (*x > xmax) {
        goto L9;
    }
    if (*x <= one) {
        goto L3;
    }
    a = exp(-(*x));
    goto L5;
L2:
    if (*x > one) {
        goto L5;
    }
    a = exp(*x);
L3:
    temp = log(*x);
    if (*x < sys073) {
        goto L4;
    }
    xx = *x * *x;
    sump = (((p[0] * xx + p[1]) * xx + p[2]) * xx + p[3]) * xx + p[4];
    sumq = ((xx + q[0]) * xx + q[1]) * xx + q[2];
    sumf = ((f[0] * xx + f[1]) * xx + f[2]) * xx + f[3];
    sumg = ((xx + g[0]) * xx + g[1]) * xx + g[2];
    x1 = (sump / sumq - xx * sumf * temp / sumg - temp) * a;
    ret_val = x1;
    if (x1 >= one) {
        ret_val += sys055;
    }
    goto L12;
L4:
    ret_val = const__ - temp;
    goto L12;
L5:
    xx = one / *x;
    sump = pp[0];
    for (i__ = 2; i__ <= 9; ++i__) {
        sump = sump * xx + pp[i__ - 1];
/* L6: */
    }
    sumq = xx;
    for (i__ = 1; i__ <= 8; ++i__) {
        sumq = (sumq + qq[i__ - 1]) * xx;
/* L7: */
    }
    sumq += qq[8];
    ret_val = sump / sumq / sqrt(*x) * a;
    goto L12;
L8:
    *ierr = 66;
    ret_val = sys059;
    goto L11;
L9:
    ret_val = zero;
    *ierr = 67;
    goto L11;
L10:
    ret_val = sys059;
    *ierr = 65;
L11:
    utsf11_c(ierr, &c__10);
L12:
    return ret_val;
} /* sf10d_c */
